USE [MC]
GO

/****** Object:  StoredProcedure [dbo].[CreateTriggerForAuditTableAll]    Script Date: 5/27/2022 2:38:21 PM ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

-- =============================================
-- Author:		Cody
-- Create date: 4/29/2022
-- Description:	Create Tiggers for all records in AuditTablesWorklist with option to delete triggers
-- =============================================
CREATE PROCEDURE [dbo].[CreateTriggerForAuditTableAll] 
	-- Add the parameters for the stored procedure here
	@DropTriggersOnly INT = 0 
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

DECLARE @Definition NVARCHAR(MAX),@TableName NVARCHAR(250),@LenDefinition INT,@DBName NVARCHAR(150), @PageID  UNIQUEIDENTIFIER
DECLARE CursorName CURSOR LOCAL FAST_FORWARD FOR
    SELECT _AuditTablesWorklist.[Database],_AuditTablesWorklist.[TableName]
	FROM MC.dbo._AuditTablesWorklist

    -- Insert statements for procedure here
OPEN CursorName
FETCH NEXT FROM CursorName INTO @DBName,@TableName
WHILE (@@FETCH_STATUS <> -1)
BEGIN
    EXEC MC.dbo.[CreateTriggerForAuditTable]        
        @TriggerType = 'Insert'
        ,@TriggerTable =  @TableName
        ,@Database = @DBName
		,@DropTriggersOnly = @DropTriggersOnly
     EXEC MC.dbo.[CreateTriggerForAuditTable]        
        @TriggerType = 'Update'
        ,@TriggerTable =  @TableName
        ,@Database = @DBName
		,@DropTriggersOnly = @DropTriggersOnly
     EXEC MC.dbo.[CreateTriggerForAuditTable]        
        @TriggerType = 'Delete'
        ,@TriggerTable =  @TableName
        ,@Database = @DBName
		,@DropTriggersOnly = @DropTriggersOnly
    FETCH NEXT FROM CursorName INTO @DBName,@TableName
END
CLOSE CursorName
DEALLOCATE CursorName
END

GO

ALTER AUTHORIZATION ON [dbo].[CreateTriggerForAuditTableAll] TO  SCHEMA OWNER 
GO

